//+------------------------------------------------------------------+
//|                                                         DCVT.mq4 |
//|                                                          Mulyadi |
//|                                                musanto@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Mulyadi"
#property link      "musanto@yahoo.com"
#define   Cx   620
#define   Cy1  50
#define   Cy2  75
#define   Cy3  100
#define   Cy4  125
#define   Cy5  150
#define   Cy6  175
#define   Cy7  200
#define   Cy8  225

extern      int      RepeatOrder = 5;
extern      double   lots        = 0.1;
extern      double   InitialTp   = 50;
extern      double   InitialSl   = 25;
extern      double   FastTrail   = 35;    // Kalau sudah 35 baru di set ke fast level
extern      double   FastLevel   = 7;     // level aman pertama 
extern      double   SlowTrail   = 45;    // Trail selanjutnya
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
datetime    VTstart;
int         VTselect,MenuDepth;
double      ep=0,                      // enter traded price
            tp=0,                      // take profit
            sl=0,                      // stop loss
            sp,
            LastEp,                    // dummy ep for modify instant order type
            LastTp,                    // dummy tp for modify instant order type
            LastSl                     // dummy sl for modify instant order type
            
            ;
int         ValidTicket,               // Valid Ticket to modify / delete   
            ot                         // order type;
            ;
int init()
  {
//----
      scrmenu();  
      VTstart     =  0;
      VTselect    =  0;
      sp = Ask-Bid;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      ObjectDelete("point1");
      ObjectDelete("point2");
      ObjectDelete("point3");
      ObjectDelete("point4");
      ObjectDelete("point5");
      ObjectDelete("point6");
      ObjectDelete("point7");
      ObjectDelete("point8");
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
//----
      Check4Close();
      if (VTselect>0 && TimeCurrent()-VTstart>100*60)      // more than 3 min command ignored.
      {
         if (VTselect==1) UndoMenu1();
         if (VTselect==2) UndoMenu2();
         if (VTselect==3) UndoMenu3();
         if (VTselect==4) UndoMenu4();
         if (VTselect==5) UndoMenu5();
         if (VTselect==6) UndoMenu5();
         if (VTselect==7) UndoMenu5();
         if (VTselect==8) UndoMenu5();
      }
      if (VTselect==0) VTselect = SelectMenu();  
      if (VTselect==1) DoMenu1();
      if (VTselect==2) DoMenu2();
      if (VTselect==3) DoMenu3();
      if (VTselect==4) DoMenu4();
      if (VTselect==5) DoMenu5();
      if (VTselect==6) DoMenu6();
      if (VTselect==7) DoMenu7();
      if (VTselect==8) DoMenu8();
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
void  UndoMenu1()
{
   VTselect = 0;
   MenuDepth=0;
   scrmenu();
   ObjectDelete("ep");
   ObjectDelete("tp");
   ObjectDelete("sl");
}
void  UndoMenu2()
{
   VTselect = 0;
   MenuDepth=0;
   scrmenu();
   ObjectDelete("ep");
   ObjectDelete("tp");
   ObjectDelete("sl");
}
void  UndoMenu3()
{  
   VTselect = 0;
   scrmenu();
   if  (MenuDepth>1)
   {
      ObjectDelete("ep");
      ObjectDelete("tp");
      ObjectDelete("sl");
   }
   MenuDepth = 0;
}
void  UndoMenu4()
{
   VTselect = 0;
   
   scrmenu();
   if  (MenuDepth>1)
   {
      ObjectDelete("ep");
      ObjectDelete("tp");
      ObjectDelete("sl");
   }
   MenuDepth = 0;
}
void  UndoMenu6()
{
   VTselect = 0;
   
   scrmenu();
   MenuDepth = 0;
}
void  UndoMenu5()
{
   VTselect = 0;
   
   scrmenu();
   MenuDepth = 0;
}
void  DoMenu7()   // Buy Instant
{  double   sl1,tp1;
   if (InitialSl>0) sl1=Bid-InitialSl*Point; else sl1 = 0;
   if (InitialTp>0) tp1=Ask+InitialTp*Point; else tp1 = 0;
   for (int i= RepeatOrder;i>0;i--)
   {
      if (OrderSend(Symbol(),OP_BUY,lots,Ask,3,sl1,tp1,"",0,0,CLR_NONE)>0)
         break;
      Sleep(5);
   }
   UndoMenu5();
   Sleep(20000);
}   
void  DoMenu8()   // Sell Instant
{  double   sl1,tp1;
   if (InitialSl>0) sl1=Ask+InitialSl*Point+Ask-Bid; else sl1 = 0;
   if (InitialTp>0) tp1=Bid-InitialTp*Point; else tp1 = 0;
   for (int i= RepeatOrder;i>0;i--)
   {
      if (OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl1,tp1,"",0,0,CLR_NONE)>0)
         break;
      Sleep(5);
   }
   Sleep(20000);
   UndoMenu5();
}   
void  DoMenu5()   // Delete ALL Pending
{
   for (int i=OrdersTotal();i>=0;i--)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT ||
             OrderType()==OP_BUYSTOP  || OrderType()==OP_SELLSTOP)
             OrderDelete(OrderTicket());
      }
   }
   UndoMenu5();
}
void  DoMenu6()
{
   for (int i=OrdersTotal();i>=0;i--)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderType()==OP_BUY  ) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         if (OrderType()==OP_SELL ) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
      }
   }
   UndoMenu6();
}
void  DoMenu4()
{  
   int   i,
         wrn;                             // line color
   double   Dist,   LastDist=100000,      // distance to compare
            Search;
   if (MenuDepth==0)   
   {  
      VTstart  = TimeCurrent();
      if (OrdersTotal()==0)       // No trade open yet
      {  
         UndoMenu4();
         return;
      }
      if (OrdersTotal()==1)        // only 1 trade opened
      {
         MenuDepth=2;
      }
   }
   if (MenuDepth==0)       // for more than 1 trade opened
   {
      VTstart = TimeCurrent();
      ObjectSet("point4",OBJPROP_XDISTANCE,Cx);
      ObjectSet("point4",OBJPROP_YDISTANCE,Cy4);
      ObjectSetText("point4","DELETE PENDING",12,"Times New Roman",Red);     // marking the menu
      ObjectCreate("ep",OBJ_HLINE,0,0,0);
      ObjectSet("ep",OBJPROP_PRICE1,Bid);                            // show pointer to modify
      ObjectSet("ep",OBJPROP_COLOR,Yellow);
      ObjectSet("ep",OBJPROP_BACK,false);
      MenuDepth = 1;
      ep = 0;
      tp = 0;
      sl = 0;
   }
   if (MenuDepth==1)
   {
      if (ObjectFind("ep")==-1) //  if this line deleted then cancel action
      {  UndoMenu4();
         return;
      }
      wrn = ObjectGet("ep",OBJPROP_COLOR);
      //
      if (wrn==Yellow)   return;  // if not recolor to other than yellow, do nothing ! 
      //
      MenuDepth = 2;
   }
   if (MenuDepth==2)
   
   {//      Seek The Closetest entry price to EP
    //      Comparing all entry PRICE  
      Comment("Delete Pending");
      if (OrdersTotal() ==1)                         // for 1 only trade opened
      {
          if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true )
          {  //Print("one traded so far");                                    
             ValidTicket = OrderTicket();
             ep          = OrderOpenPrice();
             LastEp      = ep;
             sl          = OrderStopLoss();
             tp          = OrderTakeProfit();
             ot          = OrderType();
             ObjectCreate("ep",OBJ_HLINE,0,0,0);
             if (ot==OP_BUY || ot ==OP_SELL)       // Cannot delete buy/sell done
             {
                  UndoMenu4();
                  return;
             }
          }
      } else
      {
         Search = NormalizeDouble(ObjectGet("ep",OBJPROP_PRICE1),Digits);
         for(i=0;i<OrdersTotal();i++)
         {
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
            {
               Dist = MathAbs(Search-OrderOpenPrice());
               //Print("loop ",i," Order ticket ",OrderTicket(),
               //      " ep ",Search,
               //      " open price ",OrderOpenPrice(),
               //      " dist ",Dist);
               if (Dist<=LastDist)
               {  
                  ValidTicket = OrderTicket();
                  ep          = OrderOpenPrice();
                  LastEp      = ep;
                  sl          = OrderStopLoss();
                  tp          = OrderTakeProfit();
                  ot          = OrderType();
                  LastDist    = Dist;
               }
            }
         }
         //Print("Found closetest ticket is ",ValidTicket);
         Comment("Order ticket : ",ValidTicket);
      }
      ObjectSet("ep",OBJPROP_PRICE1,ep);           // Show the shifting line
      ObjectSet("ep",OBJPROP_COLOR,Yellow);
      ObjectSet("ep",OBJPROP_BACK,false);
      ObjectCreate("tp",OBJ_HLINE,0,0,0);
      ObjectSet("tp",OBJPROP_PRICE1,tp);
      ObjectSet("tp",OBJPROP_COLOR,Lime);
      ObjectSet("tp",OBJPROP_BACK,false);
      ObjectCreate("sl",OBJ_HLINE,0,0,0);
      ObjectSet("sl",OBJPROP_PRICE1,sl);
      ObjectSet("sl",OBJPROP_COLOR,Red);
      ObjectSet("sl",OBJPROP_BACK,false);
      MenuDepth = 3;
   } //Menudepth 2
   
   if (MenuDepth==3)
   {  Comment("Delete step 3");
      for (i=RepeatOrder;i>1;i--)
      {
        if (OrderDelete(ValidTicket,CLR_NONE))
            break;
        Sleep(5);
      }   
      UndoMenu4();
   }  // Menu depth 4
}
//----------------------------------------------
void  DoMenu3()       // Modify
{  
   int   OpenTrade = OrdersTotal(),
         i,
         wrn;                             // line color
   double   Dist,   LastDist=100000,      // distance to compare
            Search;
   if (MenuDepth==0)   
   {  VTstart  = TimeCurrent();
      if (OpenTrade==0)       // No trade open yet
      {  
         UndoMenu3();
         return;
      }
      if (OpenTrade==1)        // only 1 trade opened
      {
         MenuDepth=2;
      }
   }
   if (MenuDepth==0)       // for more than 1 trade opened
   {
      VTstart = TimeCurrent();
      ObjectSet("point3",OBJPROP_XDISTANCE,Cx);
      ObjectSet("point3",OBJPROP_YDISTANCE,Cy3);
      ObjectSetText("point3","MODIFY",12,"Times New Roman",Red);     // marking the menu
      ObjectCreate("ep",OBJ_HLINE,0,0,0);
      ObjectSet("ep",OBJPROP_PRICE1,Bid);                            // show pointer to modify
      ObjectSet("ep",OBJPROP_COLOR,Yellow);
      ObjectSet("ep",OBJPROP_BACK,false);
      MenuDepth = 1;
      ep = 0;
      tp = 0;
      sl = 0;
   }
   if (MenuDepth==1)
   {
      if (ObjectFind("ep")==-1) //  if this line deleted then cancel action
      {  UndoMenu3();
         return;
      }
      wrn = ObjectGet("ep",OBJPROP_COLOR);
      //
      if (wrn==Yellow)   return;  // if not recolor to other thanYellow, do nothing ! 
      //
      MenuDepth = 2;
   }
   if (MenuDepth==2)
   
   {//      Seek The Closetest entry price to EP
    //      Comparing all entry PRICE  
      Comment("Modify order");
      if (OrdersTotal() ==1)                         // for 1 only trade opened
      {
          if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true )
          {  //Print("one traded so far");                                    
             ValidTicket = OrderTicket();
             ep          = OrderOpenPrice();
             LastEp      = ep;
             sl          = OrderStopLoss();
             LastSl      = sl;
             tp          = OrderTakeProfit();
             LastTp      = tp;
             ot          = OrderType();
             ObjectCreate("ep",OBJ_HLINE,0,0,0);
          }
      } else
      {
         Search = NormalizeDouble(ObjectGet("ep",OBJPROP_PRICE1),Digits);
         for(i=0;i<OrdersTotal();i++)
         {
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
            {
               Dist = MathAbs(Search-OrderOpenPrice());
               //Print("loop ",i," Order ticket ",OrderTicket(),
               //      " ep ",Search,
               //      " open price ",OrderOpenPrice(),
               //      " dist ",Dist);
               if (Dist<=LastDist)
               {  
                  ValidTicket = OrderTicket();
                  ep          = OrderOpenPrice();
                  LastEp      = ep;
                  sl          = OrderStopLoss();
                  LastSl      = sl;
                  tp          = OrderTakeProfit();
                  LastTp      = tp;
                  ot          = OrderType();
                  LastDist    = Dist;
               }
            }
         }
         //Print("Found closetest ticket is ",ValidTicket);
      }
      ObjectSet("ep",OBJPROP_PRICE1,ep);           // Show the shifting line
      ObjectSet("ep",OBJPROP_COLOR,Yellow);
      ObjectSet("ep",OBJPROP_BACK,false);
      ObjectCreate("tp",OBJ_HLINE,0,0,0);
      ObjectSet("tp",OBJPROP_PRICE1,tp);
      ObjectSet("tp",OBJPROP_COLOR,Lime);
      ObjectSet("tp",OBJPROP_BACK,false);
      ObjectCreate("sl",OBJ_HLINE,0,0,0);
      ObjectSet("sl",OBJPROP_PRICE1,sl);
      ObjectSet("sl",OBJPROP_COLOR,Red);
      ObjectSet("sl",OBJPROP_BACK,false);
      MenuDepth = 3;
   } //Menudepth 2
   
   if (MenuDepth==3)
   {  Comment("Modify step 3");
      //Print("mod step 3a");
      if (ObjectFind("ep")==-1) //  if this line deleted then cancel action modify
      {  UndoMenu3();
         return;
      }
      //Print("mod step 3b");
      wrn = ObjectGet("ep",OBJPROP_COLOR);      // Get the color
      if (wrn==Yellow)   return;                // if not recolor, do nothing !
      //                
      //Print("mod step 3c");
      // recolored, then get the line price   
      //Print("not yellow now");
      ep = NormalizeDouble(ObjectGet("ep",OBJPROP_PRICE1),Digits);
      if (ObjectFind("tp")!=-1) tp = NormalizeDouble(ObjectGet("tp",OBJPROP_PRICE1),Digits);
      else  
         tp = 0.0;
      if (ObjectFind("sl")!=-1) sl = NormalizeDouble(ObjectGet("sl",OBJPROP_PRICE1),Digits);
      else  
         sl = 0.0;
      // do Validation on ep/tp/sl    
      //Print("validaion");
      Comment("validasi modify");
      if (ot==OP_BUY || ot==OP_SELL)
      {//validasi instant order  
         //Print("validation instant");
         if (MathAbs(tp-Bid)<15*Point || MathAbs(sl-Bid)<15*Point)
         {  // for non valid, just cancel modify
            //Print("non valid instant");
            UndoMenu3();
            return;
         }
         if (tp==LastTp && sl==LastSl)
         {
            UndoMenu3();
            return;
         }
         // modify instant order, use last ep, cause ep is non modifiyable in instant order
         //Print("modify instant now");
         for (i=RepeatOrder;i>1;i--)
         {
            if (OrderModify(ValidTicket,LastEp,sl,tp,0,Green))
               break;
            Sleep(5);
         }   
      } else
      {// validasi pending order
         if (MathAbs(tp-ep)<15*Point || MathAbs(sl-ep)<15*Point || MathAbs(ep-Bid)<15*Point) 
         {  // for non valid, just cancel modify
            //Print("non valid pending modify");
            UndoMenu3();
            return;
         }
         if (tp==LastTp && sl==LastSl && ep==LastEp)
         {
            UndoMenu3();
            return;
         }
         // modify pending order 
         //Print("modify pending now");
         for (i=RepeatOrder;i>1;i--)
         {
            if (OrderModify(ValidTicket,ep,sl,tp,0,Green))
               break;
            Sleep(5);
         }   
      }
      UndoMenu3();
   }  // Menu depth 3
}
//---------------------------------------------------------------
void  DoMenu2()      // SELL
{  int i,wrn;
   bool     tpvalid = false,slvalid=false;
   if (MenuDepth==0)
   {
      VTstart = TimeCurrent();
      ObjectSet("point2",OBJPROP_XDISTANCE,Cx);
      ObjectSet("point2",OBJPROP_YDISTANCE,Cy2);
      ObjectSetText("point2","SELL",12,"Times New Roman",Red);
      ObjectCreate("ep",OBJ_HLINE,0,0,0);
      ObjectSet("ep",OBJPROP_PRICE1,Bid);
      ObjectSet("ep",OBJPROP_COLOR,Yellow);
      ObjectSet("ep",OBJPROP_BACK,false);
      ObjectCreate("tp",OBJ_HLINE,0,0,0);
      ObjectSet("tp",OBJPROP_PRICE1,Bid-InitialTp*Point);
      ObjectSet("tp",OBJPROP_COLOR,Lime);
      ObjectSet("tp",OBJPROP_BACK,false);
      ObjectCreate("sl",OBJ_HLINE,0,0,0);
      ObjectSet("sl",OBJPROP_PRICE1,Bid+InitialSl*Point);
      ObjectSet("sl",OBJPROP_COLOR,Red);
      ObjectSet("sl",OBJPROP_BACK,false);
      MenuDepth = 1;
      ep = 0;
      tp = 0;
      sl = 0;
   }
   if (MenuDepth==1)
   {
      wrn = ObjectGet("ep",OBJPROP_COLOR);
      if (wrn==Yellow)   return;
      ObjectSet("point1",OBJPROP_XDISTANCE,Cx);
      ObjectSet("point1",OBJPROP_YDISTANCE,Cy2);
      ObjectSetText("point1","Sell",12,"Times New Roman",Yellow);
      // validasi sell
      if (ObjectFind("ep")!=-1)
      {
         ep = NormalizeDouble(ObjectGet("ep",OBJPROP_PRICE1),Digits);
         if (ObjectFind("tp")!=-1) tp = NormalizeDouble(ObjectGet("tp",OBJPROP_PRICE1),Digits);
         if (ObjectFind("sl")!=-1) sl = NormalizeDouble(ObjectGet("sl",OBJPROP_PRICE1),Digits);
         // tp/sl validation
         if (tp!=0 && ep-tp>=15*Point) tpvalid = true;
         if (tp==0) tpvalid = true;
         if (sl!=0 && sl-ep>=15*Point) slvalid = true;
         if (sl==0) slvalid = true;
         // 
         if (tpvalid && slvalid )
         {
            if (MathAbs(Bid-ep)>=15*Point)
            {
               UndoMenu2();
               // Open Pending order
               // Open Buy stop order
               if (ep<Bid)
               {  Comment("Sell stop ",ep," ",sl," ",tp);
                  for (i=RepeatOrder;i>=1;i--)
                  {
                     if (OrderSend(Symbol(),OP_SELLSTOP,lots,ep,3,sl,tp,"",0,0,Red)>0)
                     break;
                     Sleep(5);
                  }
               }else
               // Open Limit Sell
               {  Comment("Sell limit ",ep," ",sl," ",tp);
                  for (i=RepeatOrder;i>=1;i--)
                  {
                     if (OrderSend(Symbol(),OP_SELLLIMIT,lots,ep,3,sl,tp,"",0,0,Red)>0)
                     break;
                     Sleep(5);
                  }
               }
            } else
            {  
               // wait to catch OrderClose
               MenuDepth = 2;
               Comment("Sell catch ",ep," ",sl," ",tp," ",VTselect," ",MenuDepth);
            }
         }else
             UndoMenu2();
      } else
         UndoMenu2();
   }      
   if (MenuDepth==2)
   {  
      if (ObjectFind("ep")==-1)
      {    UndoMenu2();
           return;
      }
      Comment("Sell catch ",ep," ",sl," ",tp," ",VTselect," ",MenuDepth," ",Ask," ",ObjectFind("ep"));
      if (MathAbs(Bid-ep)>=40*Point)   UndoMenu2();
      if (ObjectFind("ep")!=-1 && Bid==ep)
      {
         for (i=RepeatOrder;i>=1;i--)
         {
            if (OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,"",0,0,Lime)>0)
            {
               Comment("");
               UndoMenu2();
               break;
            }
            Sleep(5);
         }
      }
   }
}
void  DoMenu1()
{  int i,wrn;
   bool     tpvalid = false,slvalid=false;
   if (MenuDepth==0)
   {
      VTstart = TimeCurrent();
      ObjectSet("point1",OBJPROP_XDISTANCE,620);
      ObjectSet("point1",OBJPROP_YDISTANCE,50);
      ObjectSetText("point1","BUY",12,"Times New Roman",Red);
      ObjectCreate("ep",OBJ_HLINE,0,0,0);
      ObjectSet("ep",OBJPROP_PRICE1,Bid);
      ObjectSet("ep",OBJPROP_COLOR,Yellow);
      ObjectSet("ep",OBJPROP_BACK,false);
      ObjectCreate("tp",OBJ_HLINE,0,0,0);
      ObjectSet("tp",OBJPROP_PRICE1,Bid+InitialTp*Point);
      ObjectSet("tp",OBJPROP_COLOR,Lime);
      ObjectSet("tp",OBJPROP_BACK,false);
      ObjectCreate("sl",OBJ_HLINE,0,0,0);
      ObjectSet("sl",OBJPROP_PRICE1,Bid-InitialSl*Point);
      ObjectSet("sl",OBJPROP_COLOR,Red);
      ObjectSet("sl",OBJPROP_BACK,false);
      MenuDepth = 1;
      ep = 0;
      tp = 0;
      sl = 0;
   }
   if (MenuDepth==1)
   {
      wrn = ObjectGet("ep",OBJPROP_COLOR);
      if (wrn==Yellow)   return;
      ObjectSet("point1",OBJPROP_XDISTANCE,620);
      ObjectSet("point1",OBJPROP_YDISTANCE,50);
      ObjectSetText("point1","Buy",12,"Times New Roman",Yellow);
      // validasi buy
      if (ObjectFind("ep")!=-1)
      {
         ep = NormalizeDouble(ObjectGet("ep",OBJPROP_PRICE1),Digits);
         if (ObjectFind("tp")!=-1) tp = NormalizeDouble(ObjectGet("tp",OBJPROP_PRICE1),Digits);
         if (ObjectFind("sl")!=-1) sl = NormalizeDouble(ObjectGet("sl",OBJPROP_PRICE1),Digits);
         // tp/sl validation
         if (tp!=0 && tp-ep>=15*Point) tpvalid = true;
         if (tp==0) tpvalid = true;
         if (sl!=0 && ep-sl>=15*Point) slvalid = true;
         if (sl==0) slvalid = true;
         // 
         if (tpvalid && slvalid )
         {
            if (MathAbs(Bid-ep)>=15*Point)
            {
               UndoMenu1();
               // Open Pending order
               // Open Buy stop order
               if (ep>Bid)
               {  Comment("Buy stop ",ep," ",sl," ",tp);
                  for (i=RepeatOrder;i>=1;i--)
                  {
                     if (OrderSend(Symbol(),OP_BUYSTOP,lots,ep+sp,3,sl,tp,"",0,0,Lime)>0)
                     break;
                     Sleep(5);
                  }
               }else
               // Open Limit Buy
               {  Comment("Buy limit ",ep," ",sl," ",tp);
                  for (i=RepeatOrder;i>=1;i--)
                  {
                     if (OrderSend(Symbol(),OP_BUYLIMIT,lots,ep+sp,3,sl,tp,"",0,0,Lime)>0)
                     break;
                     Sleep(5);
                  }
               }
            } else
            {  
               // wait to catch OrderClose
               MenuDepth = 2;
               Comment("Buy catch ",ep," ",sl," ",tp," ",VTselect," ",MenuDepth);
            }
         }else
             UndoMenu1();
      } else
         UndoMenu1();
   }      
   if (MenuDepth==2)
   {  
      if (ObjectFind("ep")==-1)
      {
         UndoMenu1();
         return;
      }
      Comment("Buy catch ",ep," ",sl," ",tp," ",VTselect," ",MenuDepth," ",Ask," ",ObjectFind("ep"));
      if (MathAbs(Bid-ep)>=40*Point)   UndoMenu1();
      if (ObjectFind("ep")!=-1 && Bid==ep)
      {
         for (i=RepeatOrder;i>=1;i--)
         {
            if (OrderSend(Symbol(),OP_BUY,lots,Ask,3,sl,tp,"",0,0,Lime)>0)
            {
               Comment("");
               UndoMenu1();
               break;
            }
            Sleep(5);
         }
      }
   }
}
int SelectMenu()
{
   int x1,x2,x3,x4,x5,x6,x7,x8,y1,y2,y3,y4,y5,y6,y7,y8;
   x1  = ObjectGet("point1",OBJPROP_XDISTANCE);y1 = ObjectGet("point1",OBJPROP_YDISTANCE);
   x2  = ObjectGet("point2",OBJPROP_XDISTANCE);y2 = ObjectGet("point2",OBJPROP_YDISTANCE);
   x3  = ObjectGet("point3",OBJPROP_XDISTANCE);y3 = ObjectGet("point3",OBJPROP_YDISTANCE);
   x4  = ObjectGet("point4",OBJPROP_XDISTANCE);y4 = ObjectGet("point4",OBJPROP_YDISTANCE);
   x5  = ObjectGet("point5",OBJPROP_XDISTANCE);y5 = ObjectGet("point5",OBJPROP_YDISTANCE);
   x6  = ObjectGet("point6",OBJPROP_XDISTANCE);y6 = ObjectGet("point6",OBJPROP_YDISTANCE);
   x7  = ObjectGet("point7",OBJPROP_XDISTANCE);y7 = ObjectGet("point7",OBJPROP_YDISTANCE);
   x8  = ObjectGet("point8",OBJPROP_XDISTANCE);y8 = ObjectGet("point8",OBJPROP_YDISTANCE);
   
   if (x1!=Cx || y1!=Cy1) return(1);
   if (x2!=Cx || y2!=Cy2) return(2);
   if (x3!=Cx || y3!=Cy3) return(3);
   if (x4!=Cx || y4!=Cy4) return(4);
   if (x5!=Cx || y5!=Cy5) return(5);
   if (x6!=Cx || y6!=Cy6) return(6);
   if (x7!=Cx || y7!=Cy7) return(7);
   if (x8!=Cx || y8!=Cy8) return(8);
   return(0);      
}
void scrmenu()
{
   ObjectCreate("point1",OBJ_LABEL,0,0,0);   
   ObjectSet("point1",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point1",OBJPROP_YDISTANCE,Cy1);
   ObjectSetText("point1","Buy",12,"Times New Roman",Yellow);
   ObjectCreate("point2",OBJ_LABEL,0,0,0);   
   ObjectSet("point2",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point2",OBJPROP_YDISTANCE,Cy2);
   ObjectSetText("point2","Sell",12,"Times New Roman",Yellow);
   ObjectCreate("point3",OBJ_LABEL,0,0,0);   
   ObjectSet("point3",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point3",OBJPROP_YDISTANCE,Cy3);
   ObjectSetText("point3","Modify",12,"Times New Roman",Yellow);
   ObjectCreate("point4",OBJ_LABEL,0,0,0);   
   ObjectSet("point4",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point4",OBJPROP_YDISTANCE,Cy4);
   ObjectSetText("point4","Delete Pending",12,"Times New Roman",Yellow);
   ObjectCreate("point5",OBJ_LABEL,0,0,0);   
   ObjectSet("point5",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point5",OBJPROP_YDISTANCE,Cy5);
   ObjectSetText("point5","Delete ALL Pending",12,"Times New Roman",Yellow);
   ObjectCreate("point6",OBJ_LABEL,0,0,0);   
   ObjectSet("point6",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point6",OBJPROP_YDISTANCE,Cy6);
   ObjectSetText("point6","Close ALL open",12,"Times New Roman",Yellow);
   ObjectCreate("point7",OBJ_LABEL,0,0,0);   
   ObjectSet("point7",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point7",OBJPROP_YDISTANCE,Cy7);
   ObjectSetText("point7","BUY INSTANT",12,"Times New Roman",Yellow);
   ObjectCreate("point8",OBJ_LABEL,0,0,0);   
   ObjectSet("point8",OBJPROP_XDISTANCE,Cx);
   ObjectSet("point8",OBJPROP_YDISTANCE,Cy8);
   ObjectSetText("point8","SELL INSTANT",12,"Times New Roman",Yellow);
}
void  Check4Close()
{ 
  if (OrdersTotal()>0)  
  {  
     for(int i=0;i<OrdersTotal();i++)
     { 
       // Buy Section--------------------------------------------------------------------
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true          // Buy
       && OrderType()==OP_BUY)
       {  
         // Trailing Buy
         if (NormalizeDouble(OrderStopLoss()-OrderOpenPrice(),Digits)<FastLevel *Point
            && FastTrail>0     // use Fast trail are you ?
            )
         {
            if (NormalizeDouble(Bid - OrderOpenPrice(),Digits) >= FastTrail*Point)
            {   ModifSL(OrderOpenPrice()+FastLevel*Point);
            }
         } else
         {
           if (   NormalizeDouble(Bid - OrderStopLoss(),Digits) > SlowTrail*Point                // profit > slowtrail
               && SlowTrail>0     // use slow trail are you ?      
              )
           {  ModifSL(Bid-SlowTrail*Point);
           }
         }
       }
       // Sell Section--------------------------------------------------------------------
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true          // Sell
       && OrderType()==OP_SELL)
       {  
          if (NormalizeDouble(OrderOpenPrice()-OrderStopLoss(),Digits)<FastLevel*Point
              && FastTrail>0     // use Fast trail are you ?
             )
          {
             if (   NormalizeDouble(OrderOpenPrice()-Ask,Digits) >= FastTrail*Point)
             {  ModifSL(OrderOpenPrice()-FastLevel*Point);
             }
          } else
          {
            if (   NormalizeDouble(OrderStopLoss() - Ask,Digits)  > SlowTrail*Point                // profit > slowtrail
               && SlowTrail>0     // use slow trail are you ?
               )
            {   ModifSL(Ask+SlowTrail*Point);
            }
          }
       }
     }  
  }    
}
void ModifSL(double newSl)
{
   newSl=NormalizeDouble(newSl,Digits);
   for (int i=RepeatOrder;i>0;i--)
   {
      if (OrderModify(OrderTicket(),OrderOpenPrice(),newSl,OrderTakeProfit(),0,White))
          break;
      else
          Sleep(5);
    }      
}    
//+------------------------------------------------------------------+

