//+------------------------------------------------------------------+
//|                                              DynamicChannels.mq4 |
//|                                                         value808 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "value808"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White

#define MODE_HIGHLOW 1 
#define MODE_CLOSEOPEN 2
#define MODE_CLOSEOPEN2 3

//---- input parameters
extern int       mode = MODE_HIGHLOW;
extern int       bars = 0;

double RangeHistorical[];
double RangeAverage[];

double absoluteMin = 1000;
double absoluteMax = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//   SetIndexStyle(0, DRAW_HISTOGRAM,0,3);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0,RangeAverage);
   SetIndexEmptyValue(0,0);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(1,RangeHistorical);
   SetIndexEmptyValue(1,0);
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   if (bars == 0) bars = Bars;
   for (int i=bars; i>=0; i--) {
      double diff = 0;
      switch (mode) {
         case MODE_HIGHLOW:   diff = High[i]-Low[i]; break;
         case MODE_CLOSEOPEN: diff = MathAbs(Close[i]-Open[i]); break;
         case MODE_CLOSEOPEN2: diff = Close[i]-Open[i]; break;
      }
      
      if (diff > absoluteMax) {
         absoluteMax = diff;
         Print("Absolute maximum range is: ", absoluteMax, " found at offset ", i);
      }
      
      if (diff < absoluteMin) {
         absoluteMin = diff;
         Print("Absolute minimum range is: ", absoluteMin, " found at offset ", i);
      }
      
      RangeHistorical[i] = RangeHistorical[i+1]+diff;
      if (bars == i) { 
            RangeAverage[i] = diff; 
      } else {
            RangeAverage[i] = RangeHistorical[i]/(bars-i); 
      }
      
      if (mode == MODE_CLOSEOPEN2) RangeAverage[i] *= 100000;
      
/*      if (i==0) {
         Print("Bars counted: ",bars);
         Print(DoubleToStr(RangeHistorical[i],10), " ", DoubleToStr(RangeAverage[i],10));
      }*/
   }         
//----
   return(0);
}

